from ZPublisher.HTTPRequest import HTTPRequest

class ModPythonHTTPRequest(HTTPRequest):
    """ A ZPublisher HTTPRequest object that uses mod_python request object
        instead of stdout and sets environment from mod_python request object.
    """
    def __init__(self, mod_python_request, response):
        # Avoid the overhead of scrubbing the environment in the
        # case of request cloning for traversal purposes. If the
        # clean flag is set, we know we can use the passed in
        # environ dict directly.
        environ={}
        mod_python_request.add_common_vars()
        for k,v in mod_python_request.subprocess_env.iteritems():
            if k.startswith('HTTP_') or k.startswith('PATH_') or k.startswith('SERVER_') or k.startswith('REQUEST_') or k in ['CONNECTION_TYPE','REMOTE_ADDR','QUERY_STRING','CONTENT_LENGTH','CONTENT_TYPE']:
                environ[k]=v
        if mod_python_request.headers_in.has_key("authorization"):
            environ["HTTP_AUTHORIZATION"] = mod_python_request.headers_in["authorization"]
        environ["GATEWAY_INTERFACE"] = "Python-CGI/1.1"
        environ['SCRIPT_NAME']=''
        if environ.has_key('REQUEST_URI'):
            environ['PATH_INFO']=environ['REQUEST_URI'].split('?')[0]
            environ['PATH_TRANSLATED']=environ['PATH_INFO']
        if environ.has_key('HTTP_CONNECTION'):
            environ['CONNECTION_TYPE']=environ['HTTP_CONNECTION']
        HTTPRequest.__init__(self, mod_python_request, environ, response)

    def supports_retry(self): return 0


